# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.

# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
""" Copyright (c) 2000-2003 LOGILAB S.A. (Paris, FRANCE).
 http://www.logilab.fr/ -- mailto:contact@logilab.fr
"""

__revision__ = "$Id: smoketest.py,v 1.1 2003/10/01 15:40:19 syt Exp $"

import unittest
import sys
from os.path import dirname

from logilab.pylint.lint import PyLinter
from logilab.pylint.interfaces import IReporter
from utils import PREFIX

class DummyReporter:
    
    __implements____ = IReporter
    
    def add_message(self, type, module, object, line, msg):
        pass
    def display_results(self, layout):
        pass
    
class LintSmokeTest(unittest.TestCase):
    def test(self):
        sys.path.insert(0, PREFIX)
        PyLinter(reporter=DummyReporter()).check('input')
        sys.path.pop(0)
    
def suite():
    """return the unitest suite"""
    loader = unittest.TestLoader()
    module = sys.modules[__name__]
    if __name__ == '__main__' and len(sys.argv) > 1:
        return loader.loadTestsFromNames(sys.argv[1:], module)
    return loader.loadTestsFromModule(module)

def Run(runner=None):
    """run tests"""
    testsuite = suite()
    if runner is None:
        runner = unittest.TextTestRunner()
        # uncomment next line to write tests results in a file
        #runner.__init__(open('tests.log','w+'))    
    return runner.run(testsuite)
        
if __name__ == '__main__':
    Run()
