from glob import glob
from os.path import join, abspath, dirname, basename
from cStringIO import StringIO

PREFIX = abspath(dirname(__file__))

def fix_path():
    import sys
    sys.path.insert(0, PREFIX)
    
def get_tests_info(prefix=None, suffix=None):
    pattern = '*'
    if prefix:
        pattern = prefix + pattern
    if suffix:
        pattern = pattern + suffix
    result = []
    for file in glob(join(PREFIX, "input", pattern)):
        infile = basename(file)
        outfile = join(PREFIX, "messages", infile.replace(suffix, '.txt'))
        result.append((infile, outfile))
        
    return result

from logilab.pylint.interfaces import IReporter
from logilab.pylint.reporters import BaseReporter

TITLE_UNDERLINES = ['', '=', '-', '.']

class TestReporter(BaseReporter):
    """ store plain text messages 
    """
    
    __implements____ = IReporter
    
    def __init__(self):
        self.out = StringIO()

    def add_message(self, type, module, object, line, msg):
        """ manage message of different type and in the context of path """
        if type == 'info':
            # print informal messages on stderr
            print >> sys.stderr, msg
        elif type == 'fatal':
            print >>self.out, '!!!!! Fatal: %s' % (msg)
        else:
            if object:
                object = ':%s' % object
            sigle = type == 'warning' and 'W' or 'E'
            print >>self.out, '%s:%3s%s: %s' % (sigle, line, object, msg)

    def display_results(self, layout):
        pass
    
    def visit_sectionlayout(self, layout, close=0):
        pass
    
    def visit_tablelayout(self, layout):
        pass
    
    def visit_verbatimlayout(self, layout):
        pass
